#ifndef _torsmo_h_
#define _torsmo_h_

#include "config.h"
#include <stdio.h>

#define ERR(s, varargs...) \
  fprintf(stderr, "torsmo: " s "\n", ##varargs)

/* critical error */
#define CRIT_ERR(s, varargs...) \
  do { fprintf(stderr, "torsmo: " s "\n", ##varargs); exit(EXIT_FAILURE); } while(0)

struct net_stat {
  const char *dev;
  long long last_read_recv, last_read_trans;
  long long recv, trans;
  double recv_speed, trans_speed;
};

/* system dependant */

void prepare_update();
double get_uptime();
void update_meminfo();
void update_net_stats();
void update_cpu_usage();
int get_total_processes();
int get_running_processes();
double get_i2c_info(const char *dev, const char *type, int n);

/* in torsmo.c */

extern int no_buffers;

/* memory information in kilobytes */
extern unsigned int mem, memmax, swap, swapmax, bufmem;

extern double cpu_usage;

double get_time();
FILE *open_file(const char *file, int *reported);

struct net_stat *get_net_stat(const char *dev);

#endif
